//***************************************************************************
// CMG_LLIO_WaitCycles.h
//***************************************************************************
// CMG - Christian Merkle Graphics
// Copyright (C) 2oo6 - 2oo8 Christian Merkle 
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// To contact Christian Merkle, see his website at:
// http://www.cmerkle.de
//***************************************************************************
// Author:          Christian Merkle
// Created:         10.02.2007
//***************************************************************************
// History:
//   10.02.2007     *stable*
//***************************************************************************
// ToDo:
//   [ ]    xxx
//***************************************************************************

#ifndef CMG_LLIO_WAITCYCLES_H
#define CMG_LLIO_WAITCYCLES_H


#if !defined( LLIO_WR_WAITCYCLES ) || !defined( LLIO_RD_WAITCYCLES )
    #error LLIO_*_WAITCYCLES are not defined. Please customize the config file correctly using the *.config template.
#endif 


_PRIVATE
_INLINE_FORCE                       // MUST be inline
void LLIO_Write_WaitCycles( void )
{
    #if LLIO_WR_WAITCYCLES >= 1
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 2
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 3
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 4
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 5
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 6
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 7
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 8
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 9
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 10
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 11
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 12
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 13
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 14
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 15
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 16
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 17
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 18
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 19
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 20
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 21
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 22
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 23
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 24
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 25
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 26
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 27
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 28
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 29
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 30
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 31
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 32
        asm volatile ("nop");
    #endif
    #if LLIO_WR_WAITCYCLES >= 33
        #error Too many read waitcycles. Reduce number or adept this file.
    #endif
}



_PRIVATE
_INLINE_FORCE                       // MUST be inline
void LLIO_Read_WaitCycles( void )
{
    #if LLIO_RD_WAITCYCLES >= 1
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 2
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 3
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 4
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 5
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 6
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 7
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 8
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 9
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 10
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 11
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 12
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 13
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 14
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 15
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 16
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 17
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 18
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 19
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 20
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 21
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 22
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 23
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 24
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 25
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 26
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 27
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 28
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 29
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 30
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 31
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 32
        asm volatile ("nop");
    #endif
    #if LLIO_RD_WAITCYCLES >= 33
        #error Too many read waitcycles. Reduce number or adept this file.
    #endif
}



//---------------------------------------------------------------------------



#endif

/////////////////////////////////////////////////////////////////////////////
// (c) 2oo6 - 2oo8 Christian Merkle
