//***************************************************************************
// CMG_LLIO_X86_PARALLEL_8D4CTL_8080.c
//***************************************************************************
// CMG - Christian Merkle Graphics
// Copyright (C) 2oo6 - 2oo8 Christian Merkle 
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// To contact Christian Merkle, see his website at:
// http://www.cmerkle.de
//***************************************************************************
// Author:          Christian Merkle
// Created:         12.10.2006
//***************************************************************************
// History:
//   ??.??.????     *stable*
//***************************************************************************
// ToDo:
//   [ ]    find out why this one doesnt work (timig diagrams)
//   [ ]    xxx
//***************************************************************************




// #####################################
// ######## NOT STABLE YET #############
// #####################################


// #####################################
// ######## NOT WORKING YET ############
// #####################################


// #####################################
// ########### DO NOT USE ##############
// #####################################




#include    "../CMG_Main.h"

#ifndef CMG_LLIO_CONFIGURED
    #error CMG_LLIO not configured. Please customize the config file correctly (use the *.config template).
#elif defined( CMG_LLIO_X86_PARALLEL_8D4CTL_8080 )
/*    #if !defined( LLIO_DATA_PORT ) || !defined( LLIO_DATA_PIN ) || !defined( LLIO_DATA_PORT_DDR ) || \
//        #error LLIO_DATA_* and/or LLIO_CTRL_* are not defined. Please customize the config file correctly using the *.config template.
//    #endif 
*/

#error This file doesn't work yet. __Full rewrite is necessary__ (Should work like oher LLIO drivers)...
#warning Complete type checking necessary
#warning Must support windows and linux. 
#warning No comments!



#include    "CMG_LLIO.h"


#include    <windows.h>


#define LPT1                0x0378
#define LPT2                0x0278
#define LPT3                0x038C


#define LPT_PORT_BASE       LPT1
#define LPT_PORT_ECR        0x0402

#define ECR_BYTEMODE        0x20



#define BIT_iSTROBE         0
#define BIT_iAUTOFEED       1
#define BIT_INIT            2
#define BIT_iSELECT         3
#define BIT_DIRECTION       5



#define SET_STROBE_LO       dwControl = SETBIT( dwControl, BIT_iSTROBE )    // inverted
#define SET_STROBE_HI       dwControl = CLRBIT( dwControl, BIT_iSTROBE )    // inverted

#define SET_AUTOFEED_LO     dwControl = SETBIT( dwControl, BIT_iAUTOFEED )  // inverted
#define SET_AUTOFEED_HI     dwControl = CLRBIT( dwControl, BIT_iAUTOFEED )  // inverted

#define SET_INIT_LO         dwControl = CLRBIT( dwControl, BIT_INIT )       
#define SET_INIT_HI         dwControl = SETBIT( dwControl, BIT_INIT )

#define SET_SELECT_LO       dwControl = SETBIT( dwControl, BIT_iSELECT )    // inverted
#define SET_SELECT_HI       dwControl = CLRBIT( dwControl, BIT_iSELECT )    // inverted

#define SET_DIRECTION_OUT   dwControl = CLRBIT( dwControl, BIT_DIRECTION )
#define SET_DIRECTION_IN    dwControl = SETBIT( dwControl, BIT_DIRECTION )



#define SET_A0_LO_DATA      SET_SELECT_LO
#define SET_A0_HI_COMMAND   SET_SELECT_HI

#define SET_iCS_LO_SELECT   SET_STROBE_LO
#define SET_iCS_HI_DESELECT SET_STROBE_HI

#define SET_iRD_LO_READ     SET_AUTOFEED_LO
#define SET_iRD_HI_CLEAR    SET_AUTOFEED_HI

#define SET_iWR_LO_WRITE    SET_INIT_LO
#define SET_iWR_HI_CLEAR    SET_INIT_HI





#define OUTP(port,val)      __asm mov edx, port     \
                            __asm mov eax, val      \
                            __asm {out dx, al }       \
                            Sleep(1);

#define OUTPb(port,val)     __asm mov edx, port     \
                            __asm mov al, val       \
                            __asm {out dx, al}        \
                            Sleep(1);

#define INP(val,port)       __asm xor eax, eax       \
                            __asm mov edx, port     \
                            __asm in al, dx         \
                            __asm {mov val, eax  }    \
                            Sleep(1);

#define WAIT                Sleep(1);


// register addresses
cmg_u32     dwLPTPort_Data;
cmg_u32     dwLPTPort_Status;
cmg_u32     dwLPTPort_Control;
cmg_u32     dwLPTPort_ECR;

// current snapshot of control register
cmg_u32     dwControl;




cmg_Result  CMG_LLIO_Init( void )
{
    // windows stuff to enable port access
    HANDLE h = CreateFile( "\\\\.\\giveio", GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
    if ( h == INVALID_HANDLE_VALUE )
        return CMG_FAILED;
    CloseHandle(h);

    // set port addresses
    dwLPTPort_Data       = LPT_PORT_BASE;
    dwLPTPort_Status     = LPT_PORT_BASE + 1;
    dwLPTPort_Control    = LPT_PORT_BASE + 2;
    dwLPTPort_ECR        = LPT_PORT_ECR;

    // switch lpt to byte mode
    OUTP( dwLPTPort_ECR, ECR_BYTEMODE );

    // get control register
    INP( dwControl, dwLPTPort_Control );
    
    // set init ctrl
    SET_A0_HI_COMMAND;
    SET_iCS_HI_DESELECT;
    SET_iRD_HI_CLEAR;
    SET_iWR_HI_CLEAR;
    SET_DIRECTION_OUT;
    OUTP( dwLPTPort_Control, dwControl );

    return CMG_OK;
}


void    CMG_LLIO_Exit( void )
{

}



void    CMG_LLIO_WriteCommand( cmg_u8 byCommand )
{
    OUTPb( dwLPTPort_Data, byCommand );
    WAIT;

    SET_A0_HI_COMMAND;
    OUTP( dwLPTPort_Control, dwControl );

    WAIT;

    SET_iWR_LO_WRITE;
    SET_iCS_LO_SELECT;
    OUTP( dwLPTPort_Control, dwControl );
    
    WAIT;

    SET_iCS_HI_DESELECT;
    SET_iWR_HI_CLEAR;
    OUTP( dwLPTPort_Control, dwControl );
    
    WAIT;
}


cmg_u8      CMG_LLIO_ReadStatus()
{
    cmg_u32     dwStatus;

    SET_DIRECTION_IN;
    OUTP( dwLPTPort_Control, dwControl );
    
    WAIT;

    SET_A0_HI_COMMAND;
    OUTP( dwLPTPort_Control, dwControl );
    
    SET_iRD_LO_READ;
    OUTP( dwLPTPort_Control, dwControl );
    
    SET_iCS_LO_SELECT;
    OUTP( dwLPTPort_Control, dwControl );
    
    WAIT;

    INP( dwStatus, dwLPTPort_Data );

    SET_iCS_HI_DESELECT;
    OUTP( dwLPTPort_Control, dwControl );

    SET_iRD_HI_CLEAR;
    OUTP( dwLPTPort_Control, dwControl );

    SET_DIRECTION_OUT;
    OUTP( dwLPTPort_Control, dwControl );

    WAIT;
    return (cmg_u8) dwStatus;
}



void    CMG_LLIO_WriteData( cmg_u8 byData )
{
    OUTPb( dwLPTPort_Data, byData );
    WAIT;

    SET_A0_LO_DATA;
    OUTP( dwLPTPort_Control, dwControl );

    WAIT;

    SET_iWR_LO_WRITE;
    SET_iCS_LO_SELECT;
    OUTP( dwLPTPort_Control, dwControl );

    WAIT;
    
    SET_iCS_HI_DESELECT;
    SET_iWR_HI_CLEAR;
    OUTP( dwLPTPort_Control, dwControl );
    
    WAIT;
}


cmg_u8      CMG_LLIO_ReadData()
{
    cmg_u32     dwData;

    SET_DIRECTION_IN;
    OUTP( dwLPTPort_Control, dwControl );
    
    WAIT;

    SET_A0_LO_DATA;
    OUTP( dwLPTPort_Control, dwControl );
    
    SET_iRD_LO_READ;
    OUTP( dwLPTPort_Control, dwControl );
    
    SET_iCS_LO_SELECT;
    OUTP( dwLPTPort_Control, dwControl );
    
    WAIT;

    INP( dwData, dwLPTPort_Data );

    SET_iCS_HI_DESELECT;
    OUTP( dwLPTPort_Control, dwControl );

    SET_iRD_HI_CLEAR;
    OUTP( dwLPTPort_Control, dwControl );

    SET_DIRECTION_OUT;
    OUTP( dwLPTPort_Control, dwControl );

    WAIT;

    return (cmg_u8) dwData;
}

#endif

/////////////////////////////////////////////////////////////////////////////
// (c) 2oo6 - 2oo8 Christian Merkle
