//***************************************************************************
// CMG_LLIO_EMU_DISPLAY.h
//***************************************************************************
// CMG - Christian Merkle Graphics
// Copyright (C) 2oo6 - 2oo8 Christian Merkle 
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// To contact Christian Merkle, see his website at:
// http://www.cmerkle.de
//***************************************************************************
// Author:          Christian Merkle
// Created:         27.10.2006
//***************************************************************************
// History:
//   30.10.2006     *stable*
//***************************************************************************
// ToDo:
//   [ ]    xxx
//***************************************************************************

#ifndef CMG_LLIO_EMU_DISPLAY_H
#define CMG_LLIO_EMU_DISPLAY_H


//---------------------------------------------------------------------------
// Declarations      (for details see below)
//---------------------------------------------------------------------------

    //-- Init/Exit ----------------------------------------------------------
        cmg_Result  CMG_LLIO_DISPLAY_Init( void );
        void        CMG_LLIO_DISPLAY_Exit( void );
        void        CMG_LLIO_DISPLAY_PowerManagement( cmg_mu8 uState );
    //-----------------------------------------------------------------------

    //-- Write --------------------------------------------------------------
        void        CMG_LLIO_DISPLAY_SetPixel( cmg_Coord iX, cmg_Coord iY, cmg_Color Color );
    //-----------------------------------------------------------------------

    //-- Additionals --------------------------------------------------------
            #define     CMG_LLIO_DISPLAY_MODE_OFF           0
            #define     CMG_LLIO_DISPLAY_MODE_ON            1
        void        CMG_LLIO_DISPLAY_SetMode( cmg_mu8 uMode );
        void        CMG_LLIO_DISPLAY_ErrorMessage( cmg_char *strMessage );
    //-----------------------------------------------------------------------

//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
// details
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------


#endif

/////////////////////////////////////////////////////////////////////////////
// (c) 2oo6 - 2oo8 Christian Merkle
