//***************************************************************************
// CMG_LLIO_EMU_DISPLAY_COMMON.h
//***************************************************************************
// CMG - Christian Merkle Graphics
// Copyright (C) 2oo6 - 2oo8 Christian Merkle 
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// To contact Christian Merkle, see his website at:
// http://www.cmerkle.de
//***************************************************************************
// Author:          Christian Merkle
// Created:         05.11.2006
//***************************************************************************
// History:
//   07.11.2006     *stable*
//***************************************************************************
// ToDo:
//   [ ]    xxx
//***************************************************************************

#ifndef CMG_LLIO_EMU_DISPLAY_COMMON_H
#define CMG_LLIO_EMU_DISPLAY_COMMON_H


//---------------------------------------------------------------------------
// definies
//---------------------------------------------------------------------------
#define     CMG_LLIO_DISPLAY_COMMON_LCDBG_START_X              29
#define     CMG_LLIO_DISPLAY_COMMON_LCDBG_START_Y              30
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// typedefs
//---------------------------------------------------------------------------
typedef struct 
{
    cmg_u8      byBlue;
    cmg_u8      byGreen;
    cmg_u8      byRed;
    cmg_u8      byAlpha;
} cmg_PaletteColor;
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// Declarations      (for details see below)
//---------------------------------------------------------------------------

    //-- Byte Order Setting -------------------------------------------------
            #define     CMG_LLIO_DISPLAY_COMMON_BYTEORDER_GDI                 0x00
            #define     CMG_LLIO_DISPLAY_COMMON_BYTEORDER_GTK                 0x01
        void CMG_LLIO_DISPLAY_COMMON_SetByteOrder( cmg_mu8 uByteOrder );
    //-----------------------------------------------------------------------

    //-- Image Creation -----------------------------------------------------
        cmg_Result CMG_LLIO_DISPLAY_COMMON_CreateLCDImage8( cmg_u8 **ppbyImage, cmg_PaletteColor **ppPal, cmg_Coord iWidth, cmg_Coord iHeight );
        cmg_Result CMG_LLIO_DISPLAY_COMMON_CreateLCDImage32( cmg_u32 **ppdwImage, cmg_Coord iWidth, cmg_Coord iHeight );
    //-----------------------------------------------------------------------

    //-- Pixel Color Creation -----------------------------------------------
            #define     CMG_LLIO_DISPLAY_COMMON_PIXELCOLORTYPE_PHOTO_BLON     0x00
            #define     CMG_LLIO_DISPLAY_COMMON_PIXELCOLORTYPE_PHOTO_BLOFF    0x01
            #define     CMG_LLIO_DISPLAY_COMMON_PIXELCOLORTYPE_EXACT          0x02
        void CMG_LLIO_DISPLAY_COMMON_CreatePixelColor_2x2_32bpp( cmg_u32 aadwPixelColor[256][4], cmg_mu8 uType );
    //-----------------------------------------------------------------------

//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
// details
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------


#endif

/////////////////////////////////////////////////////////////////////////////
// (c) 2oo6 - 2oo8 Christian Merkle
