//***************************************************************************
// CMG_CTRL.h
//***************************************************************************
// CMG - Christian Merkle Graphics
// Copyright (C) 2oo6 - 2oo8 Christian Merkle 
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// To contact Christian Merkle, see his website at:
// http://www.cmerkle.de
//***************************************************************************
// Author:          Christian Merkle
// Created:         16.11.2006
//***************************************************************************
// History:
//   05.12.2006     *stable*
//***************************************************************************
// ToDo:
//   [ ]    xxx
//***************************************************************************

#ifndef CMG_CTRL_H
#define CMG_CTRL_H


//---------------------------------------------------------------------------
// Globals
//---------------------------------------------------------------------------
extern cmg_Coord   g_CTRL_iDisplayWidth;            // display x resolution
extern cmg_Coord   g_CTRL_iDisplayHeight;           // display y resolution
extern cmg_mu16    g_CTRL_uBytesPerLine;            // bytes per line
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// Declarations      (for details see below)
//---------------------------------------------------------------------------

    //-- Init/Exit ----------------------------------------------------------
        cmg_Result  CMG_CTRL_Init( void );
        void        CMG_CTRL_Exit( void );
        void        CMG_CTRL_PowerManagement( cmg_mu8 uState );
        cmg_Result  CMG_CTRL_ControllerSpecific( cmg_mu8 uFunction, cmg_void *pParam );
    //-----------------------------------------------------------------------

    //-- Functions ----------------------------------------------------------
        void        CMG_CTRL_FastClearScreen( cmg_u8 byCol );
        void        CMG_CTRL_SetAddressPtr( cmg_ScrAddr wScreenAddress );
    //-----------------------------------------------------------------------

    //-- Get/Set with indirect direction ------------------------------------
                                                                //_RD__WR_
            #define     CTRL_DIR_RD_NONE_WR_FASTEST     1       //  o   *
            #define     CTRL_DIR_RD_NONE_WR_RIGHT       2       //  o  ->
            #define     CTRL_DIR_RD_NONE_WR_DOWN        4       //  o   v
            #define     CTRL_DIR_RD_RIGHT_WR_INVALID    8       // ->   /
        void        CMG_CTRL_SetDirections( cmg_ms8 iDirections );

        void        CMG_CTRL_SetByte( cmg_u8 byData );
        cmg_u8      CMG_CTRL_GetByte( void );
    //-----------------------------------------------------------------------

//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// details
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------




#endif

/////////////////////////////////////////////////////////////////////////////
// (c) 2oo6 - 2oo8 Christian Merkle
