//***************************************************************************
// CMG_DRAW_Ellipse.h
//***************************************************************************
// CMG - Christian Merkle Graphics
// Copyright (C) 2oo6 - 2oo8 Christian Merkle 
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// To contact Christian Merkle, see his website at:
// http://www.cmerkle.de
//***************************************************************************
// Author:          Christian Merkle
// Created:         09.03.2007
//***************************************************************************
// History:
//   09.03.2007     *stable*
//***************************************************************************
// ToDo:
//   [ ]    xxx
//***************************************************************************

#ifndef CMG_DRAW_ELLIPSE_H
#define CMG_DRAW_ELLIPSE_H




//---------------------------------------------------------------------------
// typedefs
//---------------------------------------------------------------------------

typedef struct _cmg_DRAW_Ellipse_Data {
  // public coordinates:
    cmg_Coord       iX_Left;            // current left x
    cmg_Coord       iX_Right;           // current right x
    cmg_Coord       iY_Top;             // current top y
    cmg_Coord       iY_Bottom;          // current bottom y

  // public count:
    cmg_Coord       iCount;             // counting variable (if > 0 still have to draw)

  // private internals:
    cmg_CoordLong   iDeltaX;            // internal, (constant, mut be one time inited)
    cmg_CoordLong   iDeltaY;            // internal, (constant, mut be one time inited)
    cmg_CoordLong   iRot;               // internal
    cmg_CoordLong   iRotX;              // internal
    cmg_CoordLong   iRotY;              // internal
} cmg_DRAW_Ellipse_Data;

//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// predef
//---------------------------------------------------------------------------
_PROTECTED  void _Ellipse_OneTimeInit( cmg_DRAW_Ellipse_Data *pEllData, cmg_Coord iRadiusX, cmg_Coord iRadiusY );
_PROTECTED  void _Ellipse_LoopInside_Init( cmg_DRAW_Ellipse_Data *pEllData, cmg_Coord iMidX, cmg_Coord iMidY, cmg_Coord iRadiusX, cmg_Coord iRadiusY );
_PROTECTED  void _Ellipse_LoopOutside_Init( cmg_DRAW_Ellipse_Data *pEllData, cmg_Coord iMidX, cmg_Coord iMidY, cmg_Coord iRadiusX, cmg_Coord iRadiusY );
_PROTECTED  void _Ellipse_LoopInside( cmg_DRAW_Ellipse_Data *pEllData );
_PROTECTED  void _Ellipse_LoopOutside( cmg_DRAW_Ellipse_Data *pEllData );
//---------------------------------------------------------------------------




#endif

/////////////////////////////////////////////////////////////////////////////
// (c) 2oo6 - 2oo8 Christian Merkle
