//***************************************************************************
// CMG_DRAW_Line.h
//***************************************************************************
// CMG - Christian Merkle Graphics
// Copyright (C) 2oo6 - 2oo8 Christian Merkle 
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// To contact Christian Merkle, see his website at:
// http://www.cmerkle.de
//***************************************************************************
// Author:          Christian Merkle
// Created:         15.03.2007
//***************************************************************************
// History:
//   15.03.2007     *stable*
//***************************************************************************
// ToDo:
//   [ ]    xxx
//***************************************************************************

#ifndef CMG_DRAW_LINE_H
#define CMG_DRAW_LINE_H




//---------------------------------------------------------------------------
// typedefs
//---------------------------------------------------------------------------

typedef struct _cmg_DRAW_Line_Data {
  // public coordinates:
    cmg_Coord       iX;             // current x
    cmg_Coord       iY;             // current y

  // public count:
    cmg_Coord       iCount;         // counting variable (if > 0 still have to draw)

  // private internals:
    cmg_Coord       iDeltaLong;     // long dir delta
    cmg_Coord       iDeltaShort;    // short dir delta
    cmg_Coord       iIncLong;       // long dir increment
    cmg_Coord       iIncShort;      // short dir increment
    cmg_Coord       iDrift;         // current line error
    cmg_Coord       iLong;          // current long dir
    cmg_Coord       iShort;         // current short dir
    cmg_bool        bSwapXY;        // swaps x/y
} cmg_DRAW_Line_Data;


    // explanation:
    // if (bSwapXY == false):   Long->X, Short->Y
    //    (bSwapXY == true ):   Long->Y, Short->X

//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// predef
//---------------------------------------------------------------------------
_PROTECTED  void _Line_Loop_Init( cmg_DRAW_Line_Data *pLineData, cmg_Coord iX1, cmg_Coord iY1, cmg_Coord iX2, cmg_Coord iY2 );
_PROTECTED  void _Line_Loop( cmg_DRAW_Line_Data *pLineData );
//---------------------------------------------------------------------------




#endif

/////////////////////////////////////////////////////////////////////////////
// (c) 2oo6 - 2oo8 Christian Merkle
