//***************************************************************************
// CMG_DRAW_Main.h
//***************************************************************************
// CMG - Christian Merkle Graphics
// Copyright (C) 2oo6 - 2oo8 Christian Merkle 
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// To contact Christian Merkle, see his website at:
// http://www.cmerkle.de
//***************************************************************************
// Author:          Christian Merkle
// Created:         11.02.2007
//***************************************************************************
// History:
//   11.02.2007     *stable*
//***************************************************************************
// ToDo:
//   [ ]    xxx
//***************************************************************************

#ifndef CMG_DRAW_MAIN_H
#define CMG_DRAW_MAIN_H



//---------------------------------------------------------------------------
// Globals
//---------------------------------------------------------------------------

// display
extern  cmg_Coord   g_DRAW_iScreenSizeX;            // logical screen x size
extern  cmg_Coord   g_DRAW_iScreenSizeY;            // logical screen y size

extern  cmg_mu8     g_DRAW_uDisplayOrientationMask; // mirrow/swap flags

// clipping
extern  cmg_Coord   g_DRAW_iClippingWindow_LX;      // clipping rect left x
extern  cmg_Coord   g_DRAW_iClippingWindow_RX;      // clipping rect right x
extern  cmg_Coord   g_DRAW_iClippingWindow_TY;      // clipping rect top y
extern  cmg_Coord   g_DRAW_iClippingWindow_BY;      // clipping rect bottom y

extern  cmg_bool    g_DRAW_bProhibitCoordAdjustment;// internal use to prohibit coord adjm.

// byROPMode
extern  cmg_mu8     g_DRAW_uROPMode;                // rop mode

// drawstyle
extern  cmg_mu8     g_DRAW_uDrawStyle;              // drawstyle (border, solid, both)


// color modes
    #define     DRV_COLORMODE_SOLIDCOLOR        0x00
    #define     DRV_COLORMODE_PEN_BRUSH         0x01
extern  cmg_mu8     g_DRAW_uColorMode;              // current color mode (solid - pen)
extern  cmg_mu8     g_DRAW_uFillColorMode;          // current fillcolor mode (solid - brush)


// foreground color
extern  cmg_Color   g_DRAW_Color;                   // foreground color

// background color
extern  cmg_Color   g_DRAW_FillColor;               // background color

// pen
extern  cmg_Pen    *g_DRAW_pPen;                    // current selected pen

// brush
extern  cmg_Brush  *g_DRAW_pBrush;                  // current selected brush
extern  cmg_sfp1616 g_DRAW_sfpBrushCurrentLine;     // current brush fp line


//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// PRIVATE DRAW INTERNALS
//---------------------------------------------------------------------------

    void _DRAW_AdjustXY( cmg_Coord *pX, cmg_Coord *pY );
    
    void _DRAW_ApplyPen( cmg_Coord iSpoolX );
    void _DRAW_ApplyBrush( cmg_Coord iSpoolY );
    void _DRAW_ApplyBrushNextLine( cmg_Coord iLineSpoolX );
    
    void _DRAW_ClippedPixel( cmg_Coord iX, cmg_Coord iY );
    void _DRAW_ClippedHLine( cmg_Coord iXLeft, cmg_Coord iXRight, cmg_Coord iY, cmg_Coord iSpoolLeftmostX );

//---------------------------------------------------------------------------




#endif

/////////////////////////////////////////////////////////////////////////////
// (c) 2oo6 - 2oo8 Christian Merkle
