//***************************************************************************
// CMG_DRAW_Pixel.c
//***************************************************************************
// CMG - Christian Merkle Graphics
// Copyright (C) 2oo6 - 2oo8 Christian Merkle 
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// To contact Christian Merkle, see his website at:
// http://www.cmerkle.de
//***************************************************************************
// Author:          Christian Merkle
// Created:         11.02.2007
//***************************************************************************
// History:
//   11.02.2007     *stable*
//***************************************************************************
// ToDo:
//   [ ]    xxx
//***************************************************************************



// main CMG include (will include user configuration)
#include    "../CMG_Main.h"



//---------------------------------------------------------------------------
// conditional compilation and configuration checks
//---------------------------------------------------------------------------
#ifndef CMG_DRAW_CONFIGURED
    #error CMG_DRAW not configured. Please customize the config file correctly (use the *.config template).
#else
    // this draw file will always compile
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// inludes
//---------------------------------------------------------------------------
// CMG:
#include    "CMG_DRAW.h"
#include    "CMG_DRAW_Main.h"
#include    "../3_DRV/CMG_DRV.h"
// other:
//---------------------------------------------------------------------------






/****************************************************************************
| CMG_DRV_SetPixel
|-----------------------------------
| Set a pixel at x/y
+----------------------------------------------------------------------------
| @Params:          
|   * iX:           x coord
|   * iY:           y coord
| @Return Value:    none
+***************************************************************************/
_PUBLIC
void CMG_Pixel( cmg_Coord iX, cmg_Coord iY )
{
    // display orientation
    _DRAW_AdjustXY( &iX, &iY );
    
    // clipping
    if ( ( iX < g_DRAW_iClippingWindow_LX ) || ( iX > g_DRAW_iClippingWindow_RX ) ||
         ( iY < g_DRAW_iClippingWindow_TY ) || ( iY > g_DRAW_iClippingWindow_BY ) )
         return;

    _DRAW_ApplyPen( 0 );

    CMG_DRV_Pixel( iX, iY );
}





#endif

/////////////////////////////////////////////////////////////////////////////
// (c) 2oo6 - 2oo8 Christian Merkle
