//***************************************************************************
// CMG_TEXT.h
//***************************************************************************
// CMG - Christian Merkle Graphics
// Copyright (C) 2oo6 - 2oo8 Christian Merkle 
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// To contact Christian Merkle, see his website at:
// http://www.cmerkle.de
//***************************************************************************
// Author:          Christian Merkle
// Created:         27.08.2007
//***************************************************************************
// History:
//   02.09.2007     *stable*
//***************************************************************************
// ToDo:
//   [ ]    xxx
//***************************************************************************


#ifndef CMG_TEXT_H
#define CMG_TEXT_H



//---------------------------------------------------------------------------
// Includes
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// Font typedefs
//---------------------------------------------------------------------------
typedef     cmg_u8     cmg_FontRawData;


#define     CMG_FONTTYPE_UNCOMPRESSED       100

typedef struct _cmg_Font {
    cmg_u8              byFontType;                 // font compression type
    cmg_u8              byCharStart;                // first character index
    cmg_u8              byCharStop;                 // last character index
    cmg_u8              byLineSizeBytes;            // nr of bytes per char line
    cmg_u8              byHeight;                   // nr of lines per char
    cmg_mu16            uCharDataBytes;             // nr of data bytes per char  
    cmg_mu16            uCharOffsetBytes;           // nr of complete bytes per char
    cmg_ms8             iCharSpacing;               // spacing pixels between each char
    cmg_FontRawData     *pFontRawCharDataStart;     // pointer to raw data of first char
} cmg_Font;
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// Declarations      (for details see below)
//---------------------------------------------------------------------------

    cmg_Result  CMG_TEXT_DrawAndTextInit( void );
    void        CMG_TEXT_Exit( void );



    void        CMG_TEXT_SetTextColor( cmg_Color TextColor );
    void        CMG_TEXT_SetBackColor( cmg_Color BackColor );



    void        CMG_TEXT_Font_Create( cmg_Font *pFont, cmg_FontRawData *pFontRawData, cmg_ms8 iCharSpacing );
    cmg_Result  CMG_TEXT_Font_Set( cmg_Font *pFont );


    cmg_bool    CMG_TEXT_IsValidChar( cmg_char cChar );

    cmg_Coord   CMG_TEXT_Measure_GetTextHeight( void );
    cmg_Coord   CMG_TEXT_Measure_GetTextWidth( cmg_char *strText );



    void        CMG_TEXT_Render( cmg_Coord iX, cmg_Coord iY, cmg_char *strText );

//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
// details
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------




#endif

/////////////////////////////////////////////////////////////////////////////
// (c) 2oo6 - 2oo8 Christian Merkle
