//***************************************************************************
// CMG_TEXT_FontRawAccess_RAM.c
//***************************************************************************
// CMG - Christian Merkle Graphics
// Copyright (C) 2oo6 - 2oo8 Christian Merkle 
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// To contact Christian Merkle, see his website at:
// http://www.cmerkle.de
//***************************************************************************
// Author:          Christian Merkle
// Created:         27.08.2007
//***************************************************************************
// History:
//   02.09.2007     *stable*
//***************************************************************************
// ToDo:
//   [ ]    xxx
//***************************************************************************



// main CMG include (will include user configuration)
#include    "../CMG_Main.h"



//---------------------------------------------------------------------------
// conditional compilation and configuration checks
//---------------------------------------------------------------------------
#ifndef CMG_TEXT_CONFIGURED
    #error CMG_TEXT not configured. Please customize the config file correctly (use the *.config template).
#elif defined( CMG_TEXT_ENABLED ) && defined( CMG_TEXT_FONTRAWACCESS_RAM )
    // main text file - will always compile
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// inludes
//---------------------------------------------------------------------------
// CMG:
#include    "CMG_TEXT.h"
#include    "CMG_TEXT_Internal.h"
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// globals
//---------------------------------------------------------------------------
cmg_FontRawData     *g_TEXT_FRA_pBaseAddress;
cmg_mu16            g_TEXT_FRA_uOffset;

cmg_FontRawData     *g_TEXT_FRA_pBaseAddress_Saved;
cmg_mu16            g_TEXT_FRA_uOffset_Saved;
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// exportet functions
//---------------------------------------------------------------------------

_PROTECTED 
void _TEXT_FontRawAccess_SetBaseAddress( cmg_FontRawData *pBaseAddress )
{
    g_TEXT_FRA_pBaseAddress = pBaseAddress;
    g_TEXT_FRA_uOffset = 0;
}


_PROTECTED 
void _TEXT_FontRawAccess_SetOffset( cmg_mu16 uOffset )
{
    g_TEXT_FRA_uOffset = uOffset;
}


_PROTECTED 
cmg_u8 _TEXT_FontRawAccess_GetByte( void )
{
    return *( g_TEXT_FRA_pBaseAddress + g_TEXT_FRA_uOffset++ );
}


_PROTECTED 
void _TEXT_FontRawAccess_SaveState( void )
{
    g_TEXT_FRA_pBaseAddress_Saved = g_TEXT_FRA_pBaseAddress;
    g_TEXT_FRA_uOffset_Saved = g_TEXT_FRA_uOffset;
}


_PROTECTED 
void _TEXT_FontRawAccess_RestoreState( void )
{
    g_TEXT_FRA_pBaseAddress = g_TEXT_FRA_pBaseAddress_Saved;
    g_TEXT_FRA_uOffset = g_TEXT_FRA_uOffset_Saved;
}


//---------------------------------------------------------------------------

#endif

/////////////////////////////////////////////////////////////////////////////
// (c) 2oo6 - 2oo8 Christian Merkle
