//***************************************************************************
// CMG_TEXT_Internal.h
//***************************************************************************
// CMG - Christian Merkle Graphics
// Copyright (C) 2oo6 - 2oo8 Christian Merkle 
// 
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// To contact Christian Merkle, see his website at:
// http://www.cmerkle.de
//***************************************************************************
// Author:          Christian Merkle
// Created:         27.08.2007
//***************************************************************************
// History:
//   02.09.2007     *stable*
//***************************************************************************
// ToDo:
//   [ ]    xxx
//***************************************************************************


#ifndef CMG_TEXT_INTERNAL_H
#define CMG_TEXT_INTERNAL_H



//---------------------------------------------------------------------------
// inludes
//---------------------------------------------------------------------------
// CMG:
#include    "../4_DRAW/CMG_DRAW.h"
//---------------------------------------------------------------------------




//---------------------------------------------------------------------------
// globals
//---------------------------------------------------------------------------
extern cmg_Font    *g_TEXT_pFont;

extern cmg_Color   g_TEXT_TextColor;
extern cmg_Color   g_TEXT_TextBackColor;

extern cmg_Image   g_TEXT_ImageChar;
extern cmg_u8      *g_TEXT_pbyImageCharData;
//---------------------------------------------------------------------------



//---------------------------------------------------------------------------
// Declarations      (for details see below)
//---------------------------------------------------------------------------
    void        _TEXT_FontRawAccess_SetBaseAddress( cmg_FontRawData *pBaseAddress );
    void        _TEXT_FontRawAccess_SetOffset( cmg_mu16 uOffset );
    cmg_u8      _TEXT_FontRawAccess_GetByte( void );
    void        _TEXT_FontRawAccess_SaveState( void );
    void        _TEXT_FontRawAccess_RestoreState( void );

    cmg_Result  _TEXT_Mem_Alloc( cmg_u8 **ppbyData, cmg_mu16 uSize );
    void        _TEXT_Mem_Free( cmg_u8 **ppbyData );

    void        _TEXT_Font_Free( void );
//---------------------------------------------------------------------------





//---------------------------------------------------------------------------
// details
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------




#endif

/////////////////////////////////////////////////////////////////////////////
// (c) 2oo6 - 2oo8 Christian Merkle
