//------------------------------------------------------------------------------------------------- 
// Copyright (c) 2oo7, 2oo8 CmDev, Christian Merkle. All rights reserved.       http://www.cmdev.de
//-------------------------------------------------------------------------------------------------
// Author of this file: christian@cmdev.de

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace FontImport
{
    public partial class CodeResult : Form
    {
        private string _code;

        public CodeResult( string code, string filename )
        {
            _code = code;

            InitializeComponent();

            uxResult.Text = _code;
            saveFileDialog.FileName = filename;

            uxSave.Select();
        }

        private void uxClose_Click( object sender, EventArgs e )
        {
            Close();
        }

        private void uxCopy_Click( object sender, EventArgs e )
        {
            Clipboard.SetText( _code );
            Close();
        }

        private void uxSave_Click( object sender, EventArgs e )
        {
            saveFileDialog.ShowDialog();

            StreamWriter stream = null;
            try
            {
                stream = new StreamWriter( saveFileDialog.FileName );
                stream.Write( _code );
            }
            catch ( Exception ex )
            {
                MessageBox.Show( string.Format( "Error while saving file:{0}{1}", Environment.NewLine, ex.ToString() ), "Error",  MessageBoxButtons.OK, MessageBoxIcon.Error );
            }
            finally
            {
                if ( stream != null )
                    stream.Close();
            }
            Close();
        }
    }
}